## emoslib 4.5.1

=== CMakeLists.txt ===
################################################################################
# cmake options:
#   -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#   -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#   -DCMAKE_C_COMPILER=gcc
#   -CMAKE_Fortran_COMPILER=gfortran
#
#   -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#   -DBUILD_SHARED_LIBS=OFF

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( libemos )

enable_language( Fortran )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.6 )

ecbuild_add_option( FEATURE INSTALL_TABLES   DESCRIPTION "install BUFR/GRIBex/LSM tables"                                               DEFAULT ON )
ecbuild_add_option( FEATURE INSTALL_TOOLS    DESCRIPTION "install BUFR/GRIBex tools"                                                    DEFAULT ON )
ecbuild_add_option( FEATURE FORTRAN90        DESCRIPTION "enable tools which need Fortran 90 (only required for FC=pgf77)"              DEFAULT ON )
ecbuild_add_option( FEATURE SINGLE_PRECISION DESCRIPTION "enable single precision version of library (in addition to double precision)" DEFAULT ON )
ecbuild_add_option( FEATURE GRIBEX_ABORT     DESCRIPTION "abort execution on GRIBex calls"                                              DEFAULT ON )

ecbuild_add_option( FEATURE REQUIRE_FFTW     DESCRIPTION "require package: Fastest Fourier Transform in the West" DEFAULT ON )
ecbuild_add_option( FEATURE FFTW             DESCRIPTION "Fastest Fourier Transform in the West"                  DEFAULT ON REQUIRED_PACKAGES FFTW )
set_package_properties( FFTW PROPERTIES TYPE RECOMMENDED PURPOSE "allows interpolation of spectral to octahedral reduced Gaussian grid" )

ecbuild_add_option( FEATURE LIBEMOS_BUFRDC        DESCRIPTION "enable BUFR decoding functionality" DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_INTERPOLATION DESCRIPTION "enable interpolation functionality" DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_GRIBEX        DESCRIPTION "enable GRIBex functionality"        DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_TESTS_REGRESS DESCRIPTION "additional tests: regression"       DEFAULT OFF )


################################################################################
# compiler/linker flags

if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
  set( emos_special_system_def linux FOPEN64 )
elseif( ${CMAKE_SYSTEM_NAME} MATCHES "Darwin" )
  set( emos_special_system_def darwin )
endif()

get_filename_component(Fortran_COMPILER_NAME ${CMAKE_Fortran_COMPILER} NAME)

# double precision flags: only for d.p. Fortran-based targets (compiling & linking)
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  set(emos_double_precision_flags "-fdefault-real-8 -fdefault-double-8")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  set(emos_double_precision_flags "-r8 -i4")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
  set(emos_double_precision_flags "-r8 -i4")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  set(emos_double_precision_flags "-s integer32 -s real64")
else()
  set(emos_double_precision_flags "")
endif()

# build type flags
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  ecbuild_add_fortran_flags("-ffixed-line-length-none -fcray-pointer -fno-second-underscore -Wuninitialized -Wunused-variable -DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-O2 -mtune=native" BUILD RELEASE)
  ecbuild_add_fortran_flags("-O2 -mtune=native" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"                BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"                BUILD DEBUG)
  if(ECBUILD_MACRO_VERSION VERSION_GREATER 1.9)
    ecbuild_remove_fortran_flags("-fcheck=bounds" BUILD DEBUG)
  endif()
  include_directories(${CMAKE_Fortran_MODULE_DIRECTORY})  # EMOS-243: support for older gfortran 4.1 compiler
  set(emos_special_compiler_def "gfortran")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  ecbuild_add_fortran_flags("-DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-f77rtl"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-f77rtl -g" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-f77rtl -g" BUILD DEBUG)
  if(ECBUILD_MACRO_VERSION VERSION_GREATER 1.9)
    ecbuild_remove_fortran_flags("-check bounds" BUILD DEBUG)
  endif()
  if(HAVE_LIBEMOS_GRIBEX)
    ecbuild_add_fortran_flags("-O1" BUILD RELEASE)         # otherwise breaks GRIBex second-order packing
    ecbuild_add_fortran_flags("-O1" BUILD RELWITHDEBINFO)  # otherwise breaks GRIBex second-order packing
    ecbuild_add_fortran_flags("-O0" BUILD DEBUG)
  else()
    ecbuild_add_fortran_flags("-O3" BUILD RELEASE)
    ecbuild_add_fortran_flags("-O2" BUILD RELWITHDEBINFO)
    ecbuild_add_fortran_flags("-O0" BUILD DEBUG)
  endif()
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
  ecbuild_add_fortran_flags("-fast -Kieee -Mvect=prefetch -noswitcherror -Mextend")
  ecbuild_add_fortran_flags("-O2"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-g -O2" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"     BUILD DEBUG)
  include_directories(${CMAKE_Fortran_MODULE_DIRECTORY})  # EMOS-314: support for pgi 16.4
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  ecbuild_add_fortran_flags("-ev -Wl,--as-needed -h PIC -emf -hflex_mp=conservative -hfp1 -hadd_paren -DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-G2"       BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-G0 -hfp0" BUILD DEBUG)
  ecbuild_add_c_flags("-Wl,--as-needed -h PIC -DSHAREDMEMORY")
else()
  ecbuild_warn("No optimized Fortran compiler flags are known, we just try -O2...")
  ecbuild_add_fortran_flags("-O2"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-O2 -g" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-O0 -g" BUILD DEBUG)
endif()


################################################################################
# extra packages and projects

ecbuild_debug_var(CMAKE_PREFIX_PATH)
set( ECCODES_FAIL_MSG
    "Note: grib_api can be used instead (select with -DENABLE_ECCODES=OFF), "
    "but we strongly advise you to upgrade to ecCodes. "
    "See https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home\n" )
ecbuild_add_option( FEATURE ECCODES DESCRIPTION "Use eccodes instead of grib_api"
                    REQUIRED_PACKAGES "PROJECT eccodes VERSION 2.4.1 REQUIRED FAILURE_MSG ECCODES_FAIL_MSG"
                    DEFAULT ON )

if( HAVE_ECCODES)
  set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
  set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
  set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
  set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
  set( grib_handling_pkg eccodes )
else()
  ecbuild_use_package( PROJECT grib_api VERSION 1.23.1 REQUIRED
      FAILURE_MSG "We strongly advise to use ecCodes (enable with -DENABLE_ECCODES=ON)" )
  set( grib_handling_pkg grib_api )
endif()

################################################################################
# contents

ecbuild_declare_project()

# project export variables
set( LIBEMOS_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
set( LIBEMOS_LIBRARIES    emos ${GRIB_API_LIBRARIES} )

set_directory_properties(PROPERTIES COMPILE_DEFINITIONS "${GRIB_API_DEFINITIONS}" )

include_directories( ${LIBEMOS_INCLUDE_DIRS}  )
include_directories( ${GRIB_API_INCLUDE_DIRS} )
if( HAVE_FFTW )
  include_directories( ${FFTW_INCLUDES} )
elseif( HAVE_REQUIRE_FFTW )
  ecbuild_critical("\nCannot build without FFTW support (support is required)!")
endif()

if( BUFR_TABLES_PATH )
  if( NOT IS_ABSOLUTE "${BUFR_TABLES_PATH}" )
    set( BUFR_TABLES_PATH "${CMAKE_INSTALL_PREFIX}/${BUFR_TABLES_PATH}" )
  endif()
else()
  set( BUFR_TABLES_PATH "${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/../bufrdc_tables/" )
endif()
add_definitions( -DBUFR_TABLES_PATH="${BUFR_TABLES_PATH}" )
message( STATUS "BUFR_TABLES_PATH: ${BUFR_TABLES_PATH}" )

# get_directory_property( LIBEMOS_DEFINITIONS COMPILE_DEFINITIONS ) # don't export libemos definitions

# config header
ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/libemos )

configure_file( libemos_config.h.in  libemos_config.h  @ONLY )
configure_file( libemos_version.h.in libemos_version.h @ONLY )
configure_file( libemos_version.c.in libemos_version.c @ONLY )

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/libemos_config.h
  ${CMAKE_CURRENT_BINARY_DIR}/libemos_version.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/libemos )


################################################################################
# sources

if( HAVE_LIBEMOS_INTERPOLATION AND NOT HAVE_LIBEMOS_GRIBEX )
  message( FATAL_ERROR "\nCannot build libemos interpolation without GRIBex support!\nPlease pass option to cmake -DENABLE_LIBEMOS_GRIBEX=ON")
endif()

add_subdirectory( common )
add_subdirectory( pbio )

if( HAVE_LIBEMOS_GRIBEX )
  add_subdirectory( gribex )
endif()

if( HAVE_LIBEMOS_INTERPOLATION )
  add_subdirectory( interpolation )
  add_subdirectory( sandbox )
endif()

if( HAVE_LIBEMOS_BUFRDC )
  add_subdirectory( bufrdc_wmo )
endif()

if( ENABLE_INSTALL_TOOLS )
  add_subdirectory( tools )
endif()

if( HAVE_TESTS )
  add_subdirectory( tests )
endif()

#DEFINITIONS  FORTRAN_NO_UNDERSCORE

if( HAVE_LIBEMOS_GRIBEX )
  if( ${Fortran_COMPILER_NAME} MATCHES "ifort" OR CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
    set_source_files_properties( ${gribex_srcs} PROPERTIES COMPILE_FLAGS "-O0" )
  endif()
endif( HAVE_LIBEMOS_GRIBEX )


list( APPEND libemos_srcs
  ${emos_common_src_files}
  ${interpolation_srcs}
  ${gribex_srcs}
  ${bufrdc_wmo_srcs}
  ${pbio_srcs} )


################################################################################
# tables: BUFR and LSM interpolation

# should we install the old tables?
# probably only for new architectures
if( ENABLE_INSTALL_TABLES )
  install(
    DIRECTORY
      bufrtables
      gribtables
      gribtemplates
    DESTINATION ${INSTALL_DATA_DIR}/tables
    FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )
endif()

### interpolation tables are always installed
if( NOT INTERPOL_TABLES_PATH )
  set( INTERPOL_TABLES_PATH "${INSTALL_DATA_DIR}/tables" )
endif()

# tables path to passed as PATH into compilation -D must be absolute
if( IS_ABSOLUTE "${INTERPOL_TABLES_PATH}" )
  set(emos_interpol_tables_def INTERPOL_TABLES_PATH="${INTERPOL_TABLES_PATH}" )
else()
  set(emos_interpol_tables_def INTERPOL_TABLES_PATH="${CMAKE_INSTALL_PREFIX}/${INTERPOL_TABLES_PATH}" )
endif()
ecbuild_info( "INTERPOL_TABLES_PATH:   ${INTERPOL_TABLES_PATH}" )

# copy the tables/interpol to the build directory
file( COPY tables/interpol DESTINATION ${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR}/tables )

# always install tables/interpol
install( DIRECTORY tables/interpol DESTINATION "${INTERPOL_TABLES_PATH}" FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )
install( CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink interpol ${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/tables/land_sea_mask)" )


################################################################################
# final definitions

list( APPEND LIBEMOS_DEFINITIONS
  ${emos_special_compiler_def}
  ${emos_special_system_def}
  REAL_8
  REAL_BIGGER_THAN_INTEGER
  POINTER_64
  _LARGEFILE64_SOURCE
  _FILE_OFFSET_BITS=64
  LITTLE_ENDIAN
  INTEGER_IS_INT
  ${GRIB_API_DEFINITIONS} )

# FIXME: LITTLE_ENDIAN is not portable!
# (EMOS-172: remove this flag, only used in GRIBEX, temporarily enabled for now)


################################################################################
# targets: libraries (single & douple p.) and version-check executable

set( LIBEMOS_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR} )

if( HAVE_SINGLE_PRECISION )
  add_subdirectory( libemos-sp )
endif()
add_subdirectory( libemos-dp )

if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )
  set_source_files_properties( version.c PROPERTIES COMPILE_DEFINITIONS "FORTRAN_LINKER_PGI" )
  ecbuild_add_executable(
    TARGET      libemos_version
    DEFINITIONS ${LIBEMOS_DEFINITIONS}

=== libemos-dp/CMakeLists.txt ===
# library sources
foreach( _src ${libemos_srcs} )
  list( APPEND emos_dp_srcs ../${_src} )
endforeach()


# compiler definitions:
# - configure Fortran-based targets for double precision (compilation & linking)
# - allow/disallow GRIBEX with configuration
if (NOT emos_double_precision_flags STREQUAL "")
  ecbuild_add_fortran_flags(${emos_double_precision_flags})
endif()
if( HAVE_GRIBEX_ABORT )
  set_source_files_properties(
    "../gribex/gribex.F"
    PROPERTIES COMPILE_DEFINITIONS "GRIBEX_ABORT" )
endif()
if( HAVE_LIBEMOS_INTERPOLATION AND HAVE_FFTW )
  set_source_files_properties(
    "../interpolation/jagggp.F"
    "../interpolation/jsymgg.F"
    PROPERTIES COMPILE_DEFINITIONS "HAVE_FFTW" )
endif()


# library target
set( CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
include_directories( ${LIBEMOS_BASE_DIR}/interpolation ${LIBEMOS_BASE_DIR}/bufrdc_wmo )

ecbuild_add_library(
  TYPE        STATIC
  TARGET      emos
  OUTPUT_NAME "emosR64"
  DEFINITIONS ${LIBEMOS_DEFINITIONS} ${emos_interpol_tables_def}
  LIBS        "${GRIB_API_LIBRARIES}" "${FFTW_LIB}" ${FORTRAN_LIBRARIES}
  SOURCES     ../libemos_version.c ${emos_dp_srcs}
  GENERATED   ../libemos_version.c )


#if( BUILD_SHARED_LIBS )
#  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
#               libemosR64.so ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R64.D64.I32.so)" )
#else()
  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
               libemosR64.a ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R64.D64.I32.a)" )
#endif()

=== libemos-sp/CMakeLists.txt ===
# library sources (copy)
foreach( _src ${libemos_srcs} )
  add_custom_command(
    OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${_src}
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${LIBEMOS_BASE_DIR}/${_src} ${CMAKE_CURRENT_BINARY_DIR}/${_src}
    COMMENT "copying ${_src} from emos (sp)"
    DEPENDS ${LIBEMOS_BASE_DIR}/${_src} )
  list( APPEND emos_sp_srcs ${CMAKE_CURRENT_BINARY_DIR}/${_src} )
endforeach()


# compiler definitions:
# - exclude double-precision specific definitions
# - allow/disallow GRIBEX with configuration
list( REMOVE_ITEM LIBEMOS_DEFINITIONS REAL_8 REAL_BIGGER_THAN_INTEGER )
if( HAVE_GRIBEX_ABORT )
  set_source_files_properties(
    "${CMAKE_CURRENT_BINARY_DIR}/gribex/gribex.F"
    PROPERTIES COMPILE_DEFINITIONS "GRIBEX_ABORT" )
endif()
if( HAVE_LIBEMOS_INTERPOLATION AND HAVE_FFTW )
  set_source_files_properties(
    "${CMAKE_CURRENT_BINARY_DIR}/interpolation/jagggp.F"
    "${CMAKE_CURRENT_BINARY_DIR}/interpolation/jsymgg.F"
    PROPERTIES COMPILE_DEFINITIONS "HAVE_FFTW" )
endif()


# library target
set( CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
include_directories( ${LIBEMOS_BASE_DIR}/interpolation ${LIBEMOS_BASE_DIR}/bufrdc_wmo )

ecbuild_add_library(
  TYPE        STATIC
  TARGET      emos_sp
  OUTPUT_NAME "emos"
  DEFINITIONS ${LIBEMOS_DEFINITIONS} ${emos_interpol_tables_def}
  LIBS        "${GRIB_API_LIBRARIES}" "${FFTW_LIB}" "${FORTRAN_LIBRARIES}"
  SOURCES     ../libemos_version.c ${emos_sp_srcs}
  GENERATED   ../libemos_version.c )


#if( BUILD_SHARED_LIBS )
#  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
#               libemos.so ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R32.D64.I32.so)" )
#else()
  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
               libemos.a ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R32.D64.I32.a)" )
#endif()

=== sandbox/CMakeLists.txt ===
if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )

  set_source_files_properties( emos_tool.c PROPERTIES COMPILE_DEFINITIONS "FORTRAN_LINKER_PGI" )
  ecbuild_add_executable(
    TARGET    emos_tool
    SOURCES   emos_tool.c
    CONDITION HAVE_LIBEMOS_INTERPOLATION
    INCLUDES  ${GRIB_API_INCLUDE_DIRS}
    LIBS      emos
    LINKER_LANGUAGE Fortran )

else()

  ecbuild_add_executable(
    TARGET    emos_tool
    SOURCES   emos_tool.c
    CONDITION HAVE_LIBEMOS_INTERPOLATION
    INCLUDES  ${GRIB_API_INCLUDE_DIRS}
    LIBS      emos )

endif()

=== tests/CMakeLists.txt ===

# test settings and helper functions
include("${PROJECT_SOURCE_DIR}/tests/settings.cmake")

# configure Fortran-based targets for double precision (compilation & linking)
if (NOT emos_double_precision_flags STREQUAL "")
  ecbuild_add_fortran_flags(${emos_double_precision_flags})
endif()


################ I N T E R P O L A T I O N ################

if( HAVE_LIBEMOS_INTERPOLATION AND ENABLE_INSTALL_TOOLS )

  # intuvp2: interpolation to different formats
  foreach( rotated "" "rotated_" )
    foreach( out "regular_ll" "F80" "N80" "O80" )
      set( in "vo-d_sh" )
      set( label "intuvp2_${in}_to_${rotated}${out}" )
      if(     NOT (label MATCHES "sh_to_O" AND NOT HAVE_FFTW)
          AND NOT (label MATCHES "_to_rotated_[NOF]") )
        set( input "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib" )
        set( refer "${PROJECT_SOURCE_DIR}/tests/data/${label}.grib.ref" )
        set( output "${label}.grib" )
        unset( opt )
        if( out MATCHES "^regular_ll" )
          list( APPEND opt "--INTOUT:grid=3.0/3.0" )
        else()
          list( APPEND opt "--INTOUT:gridname=${out}" )
        endif()
        if( "${rotated}" STREQUAL "rotated_" )
          list( APPEND opt "--INTOUT:rotation=30/30" )
        endif()
        list( APPEND opt "--intuvp2" )

        interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" )
        interpolation_add_test_compare(  ${label} "${refer}" "${output}" )

        unset( opt )
        unset( output )
        unset( refer )
        unset( input )
      endif()
      unset( label )
      unset( in )
    endforeach()
  endforeach()

  # intf2: interpolation to different formats
  # not possible:
  # - regular_ll to reduced Gaussian (G) (but regular_ll to regular G is possible)
  # - regular G to reduced G
  # - any to rotated reduced/regular G
  # - regular_ll to rotated regular_ll
  foreach( rotated "" "rotated_" )
    foreach( in "vo-d_sh" "z_sh" "msl_regular_ll" "msl_N640" "2t_O640" "q_F640" )
      foreach( out "regular_ll" "F80" "N80" "O80" "F48" )
        set( label "intf2_${in}_to_${rotated}${out}" )
        if(     NOT (label MATCHES "regular_ll_to_[NO]")
            AND NOT (label MATCHES "F.*_to_[NO]")
            AND NOT (label MATCHES "_to_rotated_[NOF]")
            AND NOT (label MATCHES "regular_ll_to_rotated_regular_ll$")
            AND NOT (label MATCHES "sh_to_O" AND NOT HAVE_FFTW) )
          set( input "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib" )
          set( refer "${PROJECT_SOURCE_DIR}/tests/data/${label}.grib.ref" )
          set( output "${label}.grib" )
          unset( opt )
          if( out MATCHES "^regular_ll" )
            list( APPEND opt "--INTOUT:grid=0.5/0.5" )
          else()
            list( APPEND opt "--INTOUT:gridname=${out}" )
          endif()
          if( "${rotated}" STREQUAL "rotated_" )
            list( APPEND opt "--INTOUT:rotation=30/30" )
          endif()
          list( APPEND opt "--INTOUT:autoresol=1" "--INTOUT:area=0/0/0/0" "--intf2" )

          interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" )
          interpolation_add_test_compare( ${label} "${output}" "${refer}" )

          unset( opt )
          unset( output )
          unset( refer )
          unset( input )
        endif()
        unset( label )
      endforeach()
    endforeach()
  endforeach()


  # intf2: interpolate to N/O grids with the same N
  # (distinguish between N640 <> O640)
  foreach( in "N640" "O640" )
    foreach( out "N640" "O640" )
      set( label "intf2_${in}_to_${out}" )
      set( output "${label}.grib" )
      unset( opt )
      list( APPEND opt "--INTOUT:gridname=${out}" "--INTOUT:autoresol=1" "--INTOUT:area=0/0/0/0" "--intf2" )

      if( in MATCHES "N640" )
        set( input "${PROJECT_SOURCE_DIR}/tests/data/msl_${in}.grib" )
      else()
        set( input "${PROJECT_SOURCE_DIR}/tests/data/2t_${in}.grib" )
      endif()
      interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" )
      interpolation_add_test_compare(  ${label} "${input}" "${output}" )
      interpolation_add_test_gridname( ${label} ${output} ${out} )
      if( NOT in STREQUAL out )
        set_tests_properties( ${label}_compare PROPERTIES WILL_FAIL TRUE )
      endif()

      unset( opt )
      unset( input )
      unset( output )
      unset( label )
    endforeach()
  endforeach()


  # intf2: compare FFT99 vs FFTW exactly (no tolerance!)
  if( HAVE_FFTW )
    foreach( in "vo-d_sh" "z_sh" )
      set( input "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib" )
      set( output_fftw  "intf2_${in}_to_N80-fftw.grib" )
      set( output_fft99 "intf2_${in}_to_N80.grib" )
      unset( opt )
      list( APPEND opt "--INTOUT:gridname=N80" "--INTOUT:autoresol=1" "--intf2" )

      interpolation_add_test_interpol( "intf2_${in}_to_N80_fft99_vs_fftw" "${input}" "${output_fftw}" "${opt}" "" "EMOSLIB_FORCED_FFTW=1" )
      interpolation_add_test_compare( "intf2_${in}_to_N80_fft99_vs_fftw" "${output_fftw}" "${output_fft99}" )

      unset( opt )
      unset( output_fft99 )
      unset( output_fftw )
      unset( input )
    endforeach()
  endif( HAVE_FFTW )


  # intf2: test SH truncation
  set( in "vo-d_sh" )
  set( opt "--INTOUT:truncation=63" "--intf2" )
  interpolation_add_test_interpol(
      "intf2_${in}_to_${in}_trunc"
      "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib"
      "intf2_${in}_to_${in}_trunc.grib"
      "${opt}" )
  unset( opt )
  unset( in )


endif( HAVE_LIBEMOS_INTERPOLATION AND ENABLE_INSTALL_TOOLS )


####################### G R I B E X #######################

if( HAVE_LIBEMOS_GRIBEX )

    ecbuild_add_test( TARGET gribex_abort SOURCES gribex_abort.F LIBS emos ENVIRONMENT ${_emos_environment} )
    ecbuild_add_test( TARGET gribex_demo  SOURCES gribex_demo.F  LIBS emos ENVIRONMENT ${_emos_environment}
      ARGS -i "${PROJECT_SOURCE_DIR}/tests/data/msl_regular_ll.grib" )

    set_tests_properties( gribex_abort PROPERTIES WILL_FAIL ${HAVE_GRIBEX_ABORT} )
    set_tests_properties( gribex_demo  PROPERTIES WILL_FAIL ${HAVE_GRIBEX_ABORT} )

endif( HAVE_LIBEMOS_GRIBEX )


######################### B U F R #########################

if( HAVE_LIBEMOS_BUFRDC AND ENABLE_INSTALL_TOOLS )
  add_subdirectory( bufr )
endif( HAVE_LIBEMOS_BUFRDC AND ENABLE_INSTALL_TOOLS )


############ T E S T S :   R E G R E S S I O N ############

if( HAVE_LIBEMOS_INTERPOLATION AND ENABLE_INSTALL_TOOLS )
  if( HAVE_LIBEMOS_TESTS_REGRESS )
    add_subdirectory( regress )
  endif()
endif( HAVE_LIBEMOS_INTERPOLATION AND ENABLE_INSTALL_TOOLS )


###################### M S   A P P S ######################

add_subdirectory( ms_apps )


################ S P E C I A L   T E S T S ################

if( HAVE_LIBEMOS_INTERPOLATION )

    # linking (build-time) test(s)
    foreach( src "example_intf2.F" "example_intuvp2.F" "link_mars.F" "link_prodgen.F" )
        get_filename_component( test ${src} NAME_WE )
        ecbuild_add_executable( TARGET ${test} NOINSTALL SOURCES ${src} LIBS emos )
        unset( test )
    endforeach()
    ecbuild_add_executable( TARGET "example_intf" NOINSTALL SOURCES "example_intf.F90" LIBS emos CONDITION (NOT CMAKE_Fortran_COMPILER_ID MATCHES "PGI") )

    # run-time test(s)
    foreach( test "test_fft99" "test_hsp2gg" )
        ecbuild_add_test( TARGET ${test} SOURCES ${test}.F LIBS emos )
    endforeach()
    ecbuild_add_test( TARGET "test_fftw" SOURCES "test_fftw.F" LIBS emos CONDITION HAVE_FFTW )

endif( HAVE_LIBEMOS_INTERPOLATION )

=== tests/ms_apps/CMakeLists.txt ===

# https://software.ecmwf.int/wiki/display/MSAPP/Single+Point+Interpolation

list(APPEND list_samples "singlePointInterpolation")
if (HAVE_ECCODES)
  list(APPEND list_samples "singlePointInterpolation_eccodes")
endif()

foreach(sample ${list_samples})

  ecbuild_add_executable(
    TARGET      "ms_apps_${sample}" NOINSTALL
    SOURCES     "${sample}.f90"
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    INCLUDES    ${GRIB_API_INCLUDE_DIRS}
    LIBS        emos )

  foreach(in "2t_O640" "msl_N640" "z_sh")
    set(input "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib")
    set(output "ms_apps_${sample}_run1_ouput")
    set(points "${PROJECT_SOURCE_DIR}/tests/ms_apps/input_single_points")

    if (NOT in MATCHES "_sh$" OR HAVE_FFTW)
      ecbuild_add_test(
        TARGET       "ms_apps_${sample}_${in}_bin"
        COMMAND      "ms_apps_${sample}"
        ARGS         "${points}" "${input}" "${output}"
        ENVIRONMENT  "CONFIG_INTERP=ON_FLY" ${_grib_environment} )

      set(output "ms_apps_${sample}_run2_ouput")
      ecbuild_add_test(
        TARGET       "ms_apps_${sample}_${in}_txt"
        COMMAND      "ms_apps_${sample}"
        ARGS         "${points}" "${input}" "${output}" "ascii"
        ENVIRONMENT  "CONFIG_INTERP=ON_FLY" ${_grib_environment} )
    endif()

    unset(points)
    unset(output)
    unset(input)
  endforeach()

endforeach()

=== tests/regress/CMakeLists.txt ===

# Download interpolation source files/reference results

file(STRINGS "download_tests_regress_src_files.txt" files)
ecbuild_get_test_multidata(
    TARGET download_tests_regress_src_files NOCHECK
    NAMES ${files} )

file(STRINGS "download_tests_regress_ref_files.txt" files)
ecbuild_get_test_multidata(
    TARGET download_tests_regress_ref_files NOCHECK
    NAMES ${files} )


######################### EMOS-216 #########################

# some interpolations are not possible:
# - regular_ll to reduced_gg (but regular_ll to regular_gg is possible)
# - regular_gg to reduced_gg
# - any to rotated reduced_gg/regular_gg
# - regular_ll to rotated regular_ll
# - ... HIRLAM restrictions?
# - any to octahedral without FFTW
# - swh_reduced_ll interpolations (SIGFPE, Arithmetic exception in INTIN) (FIXME: temporary disabling)
foreach( area "" "_sub-area" )
  foreach( in "vo-d_sh" )
    foreach( out "regular_ll" "F80" "N80" "O80" )
      set( label "regress_EMOS-216_intuvp2_${in}_to_${out}${area}" )
      set( input "${in}.grib" )
      set( output "${label}.grib" )
      if( NOT (label MATCHES "_sh_to_O" AND NOT HAVE_FFTW) )
        unset( opt )
        if( out MATCHES "^regular_ll" )
          list( APPEND opt "--INTOUT:grid=3/3" )
        else()
          list( APPEND opt "--INTOUT:gridname=${out}" )
        endif()
        if( "${area}" STREQUAL "_sub-area" )
          list( APPEND opt "--INTOUT:area=70/-60/20/60" )
        endif()
        list( APPEND opt "--intuvp2" )

        interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" download_tests_regress_src_files )
        interpolation_add_test_compare( ${label} "${output}" "${output}.ref"      download_tests_regress_ref_files )

        unset( opt )
      endif()
      unset( output )
      unset( input )
      unset( label )
    endforeach()
  endforeach()
endforeach()

foreach( area "" "_sub-area" )
  foreach( rotated "" "rotated_" "hirlam_non-rotated_" )
    foreach( in
        "2t_F640"
        "2t_F640_sub-area"
        "2t_N640"
        "2t_O1280"
        "2t_regular_ll"
        "2t_regular_ll_staggered"
        "2t_regular_ll_sub-area"
        "msl_F640"
        "msl_F640_sub-area"
        "msl_N640"
        "msl_O1280"
        "msl_regular_ll"
        "msl_regular_ll_sub-area"
        "mwd3_reduced_ll"
        "swh_reduced_ll"
        "swh_reduced_ll_sub-area"
        "u-v_sh"
        "z_sh" )
      foreach( out "regular_ll" "F80" "N80" "O80" "F48" )
        set( label "regress_EMOS-216_intf2_${in}_to_${rotated}${out}${area}" )
        set( input "${in}.grib" )
        set( output "${label}.grib" )
        if(     NOT (label MATCHES "_sub-area_to_" AND NOT label MATCHES "_to_.*_sub-area")
            AND NOT (label MATCHES "_regular_ll.*_to_[NO]")
            AND NOT (label MATCHES "_F.+_to_[NO]")
            AND NOT (label MATCHES "(F.+|reduced_ll)_to_.*rotated_regular_ll")
            AND NOT (label MATCHES "_to_[NO].*_sub-area")
            AND NOT (label MATCHES "_to_.*rotated_[NOF]")
            AND NOT (label MATCHES "_to_.*rotated_.*sub-area")
            AND NOT (label MATCHES "_regular_ll.*_to_.*rotated_regular_ll$")
            AND NOT (label MATCHES "_reduced_ll_sub-area_to_.*")  # FIXME
            AND NOT (label MATCHES "_reduced_ll_to_[FNO]")        # FIXME: EMOS-286)
            AND NOT (label MATCHES "_reduced_ll_to_regular_ll")   # FIXME: problems comparing gnu/pgi results (opensuse131)
            AND NOT (label MATCHES "_sh_to_O" AND NOT HAVE_FFTW) )
          unset( opt )
          if( out MATCHES "^regular_ll" )
            list( APPEND opt "--INTOUT:grid=3/3" )
          else()
            list( APPEND opt "--INTOUT:gridname=${out}" )
          endif()
          if( "${rotated}" STREQUAL "hirlam_non-rotated_" )
            list( APPEND opt "--INTOUT:rotation=-90/0" )
          elseif( "${rotated}" STREQUAL "rotated_" )
            list( APPEND opt "--INTOUT:rotation=30/30" )
          endif()
          if( "${area}" STREQUAL "_sub-area" )
            list( APPEND opt "--INTOUT:area=70/-60/20/60" )
          endif()
          list( APPEND opt "--intf2" )

          interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" download_tests_regress_src_files )
          interpolation_add_test_compare( ${label} "${output}" "${output}.ref"      download_tests_regress_ref_files )

          unset( opt )
        endif()
        unset( output )
        unset( input )
        unset( label )
      endforeach()
    endforeach()
  endforeach()
endforeach()


######################### EMOS-260 #########################

set( label "regress_EMOS-260_intf2_2t_N640_to_regular_ll_sub-area" )
set( input "2t_N640.grib" )
set( output "${label}.grib" )
set( opt "--INTOUT:area=47.1/-13.05/33/8.1" "--INTOUT:grid=0.15/0.15" )
list( APPEND opt "--intf2" )

interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" download_tests_regress_src_files )
interpolation_add_test_compare( ${label} "${output}" "${output}.ref"      download_tests_regress_ref_files )

unset( opt )
unset( output )
unset( input )
unset( label )


######################### EMOS-262 #########################

set( label "regress_EMOS-262_intf2_msl_N640_to_regular_ll_sub-area_single-point" )
set( input "msl_N640.grib" )
set( output "${label}.grib" )
set( opt "--INTOUT:area=45.5/9.25/45.5/9.25" "--INTOUT:grid=0.125/0.125" )
list( APPEND opt "--intf2" )

interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" download_tests_regress_src_files )
interpolation_add_test_compare( ${label} "${output}" "${output}.ref"      download_tests_regress_ref_files )

unset( opt )
unset( output )
unset( input )
unset( label )


######################### EMOS-269 #########################

foreach( singleopt "--INTOUT:accuracy=16" "--INTOUT:interpolation=\"nearest neighbour\"" )
  if( singleopt MATCHES "accuracy" )
    set( label "regress_EMOS-269_intf2_msl_O1280_to_O1280_nointerpol_accuracy" )
  elseif( singleopt MATCHES "nearest neighbour" )
    set( label "regress_EMOS-269_intf2_msl_O1280_to_O1280_nointerpol_nearestn" )
  endif()
  set( input "msl_O1280.grib" )
  set( output "${label}.grib" )
  set( opt ${singleopt} )
  list( APPEND opt "--intf2" )

  interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" download_tests_regress_src_files )
  interpolation_add_test_gridname( ${label} "${output}" "O1280" )

  unset( opt )
  unset( output )
  unset( input )
  unset( label )
endforeach()


######################### EMOS-274 #########################

set( label "regress_EMOS-274_intf2_2t_N128_custompl_to_F64" )
set( input "2t_N128_custompl.grib" )
set( output "${label}.grib" )
set( opt "--INTOUT:gridname=F64" )
list( APPEND opt "--intf2" )

interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" download_tests_regress_src_files )
interpolation_add_test_compare(  ${label} "${output}" "${output}.ref"     download_tests_regress_ref_files )
interpolation_add_test_gridname( ${label} "${output}" "F64" )

unset( opt )
unset( output )
unset( input )
unset( label )


################### GRIB-863 / EMOS-214 ####################

# GRIB1 interpolate to regular_ll (1/16)/(1/16) degree
foreach( in "2t_O1280" )
  set( label "regress_GRIB-863_intf2_${in}_to_regular_ll_1-16" )
  set( input "${in}.grib" )
  set( output "${label}.grib" )
  set( opt "--INTOUT:grid=0.0625/0.0625" )
  list( APPEND opt "--intf2" )

  interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" download_tests_regress_src_files )
  interpolation_add_test_compare( ${label} "${output}" "${output}.ref"      download_tests_regress_ref_files )

  unset( opt )
  unset( output )
  unset( input )
  unset( label )
endforeach()


######################### GRIB-864 #########################

# GRIB1 sub-milli degree encoding limit
# snap-milli-degree:     snaps to 0.001 because grid is 0.00025/0.00025, and is GRIB1-encodable
# snap-sub-milli-degree: snaps to 0.0005, not GRIB1-encodable (failure expected)
foreach( snap "snap-milli-degree" "snap-sub-milli-degree_bad" "snap-sub-milli-degree_sub-area_bad" )
  set( label "regress_GRIB-864_intf2_msl_N640_to_regular_ll_${snap}" )
  set( input "msl_N640.grib" )
  set( output "${label}.grib" )
  if(     snap STREQUAL "snap-sub-milli-degree_sub-area_bad" )
    set( opt "--INTOUT:grid=0.0625/0.0625"   "--INTOUT:area=1/0.0625/0/0.5625" )
  elseif( snap STREQUAL "snap-sub-milli-degree_bad" )
    set( opt "--INTOUT:grid=0.00025/0.00025" "--INTOUT:area=0.00074/0/0/0.00074" )
  else()
    set( opt "--INTOUT:grid=0.00025/0.00025" "--INTOUT:area=0.00076/0/0/0.00076" )
  endif()
  list( APPEND opt "--intf2" )

  interpolation_add_test_interpol( ${label} "${input}" "/dev/null" "${opt}" download_tests_regress_src_files )
  if( snap MATCHES "sub-milli-degree" )
    set_tests_properties( ${label}_interpol PROPERTIES WILL_FAIL TRUE )
  endif()

  unset( opt )
  unset( output )
  unset( input )
  unset( label )
endforeach()


#################### ECC-511 / EMOS-320 ####################

set( label "regress_ECC-511_intf2_sde_regular_ll_complex_spatial_differencing_to_regular_ll" )
set( input "sde_regular_ll_complex_spatial_differencing.grib2" )
set( output "${label}.grib2" )
set( opt "--INTOUT:grid=3/3" )
list( APPEND opt "--intf2" )

interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" download_tests_regress_src_files )
interpolation_add_test_compare(  ${label} "${output}" "${output}.ref"     download_tests_regress_ref_files )

unset( opt )
unset( output )
unset( input )
unset( label )


############################################################

=== tools/bufrtools_wmo/CMakeLists.txt ===

# configure Fortran-based targets for double precision (compilation & linking)
if (NOT emos_double_precision_flags STREQUAL "")
  ecbuild_add_fortran_flags(${emos_double_precision_flags})
endif()


# if( CMAKE_Fortran_COMPILER_ID MATCHES "GNU" )
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-ffixed-form" )
# elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-fixed" )
# elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-f fixed" )
# endif()


################################################################################
# sources

list( APPEND bufrtools_bins_F77
  bufr_0t2
  bufr_88t89
  bufr_check
  bufr_compress
  bufr_decode
  bufr_decode_all
  emoslib_bufr_filter
  bufr_key
  bufr_nt1
  bufr_ntm
  bufr_obs_filter
  bufr_repack
  bufr_repack_206t205
  bufr_repack_satid
  bufr_ship_anmh
  bufr_ship_anmh_ERA
  bufr_split
  snow_key_repack )

list( APPEND bufrtools_bins_F90
  bufr_add_bias
  bufr_merg
  bufr_merge_tovs
  bufr_simulate )

list( APPEND bufrtools_bins_tracks
  tc_tracks
  tc_tracks_10t5
  tc_tracks_det
  tc_tracks_eps )


################################################################################
# F77

ecbuild_add_library(
  TARGET  my_exit NOINSTALL
  TYPE    STATIC
  SOURCES my_exit.F )

foreach( tool ${bufrtools_bins_F77} )
  ecbuild_add_executable(
    TARGET      ${tool}
    SOURCES     ${tool}.F
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    LIBS        my_exit emos )
endforeach()


################################################################################
# F90

if( ENABLE_FORTRAN90 )

  ecbuild_add_library(
    TARGET  bufr_module NOINSTALL
    TYPE    STATIC
    SOURCES mod_bufr.F90 )

  foreach( tool ${bufrtools_bins_F90} )
    ecbuild_add_executable(
      TARGET      ${tool}
      SOURCES     ${tool}.F90
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      LIBS        my_exit emos )
  endforeach()

  foreach( tool ${bufrtools_bins_tracks} )
    ecbuild_add_executable(
      TARGET      ${tool}
      SOURCES     ${tool}.F90
      CONDITION   HAVE_LIBEMOS_GRIBEX
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      LIBS        bufr_module my_exit emos )
  endforeach()

  ecbuild_add_executable(
      TARGET      grib2bufr
      SOURCES     grib2bufr.F90
      CONDITION   HAVE_LIBEMOS_GRIBEX
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      LIBS        my_exit emos )

endif( ENABLE_FORTRAN90 )


################################################################################
# scripts

# bufr_filter script (See EMOS-242)
install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_filter
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )

=== tools/lsmReducedGaussian/CMakeLists.txt ===

# configure Fortran-based targets for double precision (compilation & linking)
if (NOT emos_double_precision_flags STREQUAL "")
  ecbuild_add_fortran_flags(${emos_double_precision_flags})
endif()

ecbuild_add_executable(
  TARGET      ginout_c2 NOINSTALL
  SOURCES     ginout_c2.f90
  DEFINITIONS ${LIBEMOS_DEFINITIONS}
  INCLUDES    ${GRIB_API_INCLUDE_DIRS}
  LIBS        emos )

=== tools/singlePointInterpolation/CMakeLists.txt ===

# configure Fortran-based targets for double precision (compilation & linking)
if (NOT emos_double_precision_flags STREQUAL "")
  ecbuild_add_fortran_flags(${emos_double_precision_flags})
endif()


# executable
ecbuild_add_executable(
  TARGET  singlePointInterpolation
  SOURCES singlePointInterpolation.F
  LIBS    emos )

=== debian/changelog ===
emoslib (2:4.5.1-1) unstable; urgency=medium

  * New upstream release
  * refresh patches; fix-version.patch no longer needed
  * Define ECCODES_DEFINITION_PATH in debian/rules for tests
  * Depends on libeecodes-dev >= 2.4.1
  * Standards-Version: 4.0.1

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 15 Aug 2017 09:01:13 +0100

emoslib (2:4.5.0-1) unstable; urgency=medium

  * New upstream release
  * Add debian/gbp.conf file
  * Change libemos-data to Arch: all

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 21 Jul 2017 16:41:37 +0100

emoslib (2:4.4.9-1) unstable; urgency=medium

  * New upstream release
    - Updated shared.patch. SONAME,SOVERSIO no longer needed
  * Standards-Version: 4.0.0
  * Add watch file

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 04 Jul 2017 14:21:19 +0100

emoslib (2:4.4.7-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Jun 2017 06:13:05 +0100

emoslib (2:4.4.7-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 24 Mar 2017 13:09:45 +0000

emoslib (2:4.4.6-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 21 Feb 2017 13:23:08 +0000

=== debian/control ===
Source: emoslib
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>=10), gfortran, cmake (>= 2.8.11), 
 libboost-dev (>= 1.47.0), libboost-test-dev, chrpath,
 libeccodes-dev (>= 2.4.1),
 libeccodes-tools | libgrib-api-tools,
 libopenjp2-7-dev,
 zlib1g-dev,
 libfftw3-dev,
 libpython2.7-dev, libnetcdf-dev
Standards-Version: 4.0.1
Homepage: https://software.ecmwf.int/wiki/display/EMOS/Emoslib
Vcs-Git: git://anonscm.debian.org/debian-science/packages/emos.git

Package: libemos0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data
Pre-Depends: ${misc:Pre-Depends}
Description: ECMWF Interpolation Library
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.

Package: libemos-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libemos0d ( = ${binary:Version}), ${misc:Depends}, libeccodes-tools | libemos-bin:any 
Recommends: pkg-config
Description: ECMWF Interpolation Library - development
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.
 .
 This package contains the static libraries and headers needed to build 
 applications against libemos.

Package: libemos-bin
Section: libs
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data, libeccodes-tools
Description: ECMWF Interpolation Library - binaries
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB,
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological
 archival and retrieval system (MARS) and also by the ECMWF graphics
 package MetView.
 .
 This package provide bufr-* and other tools

Package: libemos-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files for the ECMWF Interpolation library
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.
 .
 This package contains the data files needed by EMOSLIB.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

export DEB_LDFLAGS_MAINT_PREPEND := -Wl,-z,defs -Wl,--as-needed

export ECCODES_DEFINITION_PATH=/usr/share/eccodes/definitions/

DESTDIR:=$(shell pwd)/debian/tmp
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ARCH:=$(shell dpkg --print-architecture)
AUTOGENERATED:= libemos-dev.install libemos-dev.links libemos0d.install
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
CMAKE_DIR:=debian/tmp/share/libemos/cmake
DO_TEST:=true


# Do tests on little-endian only for the moment;
ENDIAN:=$(shell dpkg-architecture -qDEB_BUILD_ARCH_ENDIAN)

FPIC_LIST:= "s390x amd64 ppc64el m68k sparc64"
ifneq (,$(findstring $(ARCH),$(FPIC_LIST)))
  FPIC:= -fPIC
else
  FPIC:= -fpic
endif

MCMODEL_FLAGS:=''
BUILD_FLAGS:=''

ifeq ($(ARCH), amd64)
  MCMODEL_FLAGS:= -mcmodel=medium
endif
ifeq ($(ARCH), sparc64)
  MCMODEL_FLAGS:= -mcmodel=medany
endif
ifeq ($(ARCH), ppc64el)
  MCMODEL_FLAGS:= -mcmodel=large
endif
ifeq ($(ARCH), hurd-i386)
  BUILD_FLAGS:= ' -D__GNU__'
endif

override_dh_auto_test:
	# Need links for tests.
	(cd bufrtables && sh ./links.sh)
	 $(ENDIAN)==little && dh_auto_test || echo "Tests disabled on bigendian systems for the moment"

override_dh_auto_clean:
	find bufrtables -type l -delete
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- \
		-Dgrib_api_BASE_DIR=/usr \
		-DECBUILD_LOG_LEVEL=DEBUG \
		-DENABLE_FFTW=ON \
		-DENABLE_LITTLE_ENDIAN=$(LITTLE) \
		-DCMAKE_INSTALL_PREFIX=${DESTDIR} \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_SHARED_LIBS=ON \
		-DDISABLE_OS_CHECK=ON \
		-DMCMODEL_FLAGS=${MCMODEL_FLAGS} \
		-DBUILD_FLAGS=${BUILD_FLAGS} \
		-DFPIC=${FPIC} \
		-DINSTALL_LIBDIR=${LIBDIR} \
		-DINTERPOL_TABLES_PATH=/usr/share/emos \
		-DBUFR_TABLES_PATH=/usr/share/emos/bufrtables \
		-DTEST_BUFR_TABLES_PATH=${CURDIR}/bufrtables
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
		done

override_dh_auto_build:
	dh_auto_build
	# Need to be installed into debian/tmp before tests
	cd obj-* && $(MAKE) install

# TODO: CHECK INTERPOL_TABLES_PATH is set correctly.		

override_dh_auto_install:
	cd obj-* && $(MAKE) install
	for d in debian/tmp/bin/* ; do \
		( chrpath -d $$d || echo "Ignoring non-ELF file errors") ; done
	chrpath -d debian/tmp/lib/*.0d
	(cd ${DESTDIR}/share/libemos/tables/bufrtables && sh ./links.sh)
	# Now in libeccodes
	rm -f debian/tmp/bin/bufr_filter
	dh_auto_install	
	# Fix broken paths 
	cat ${CMAKE_DIR}/libemos-targets-release.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR}/tmp
	mv ${CMAKE_DIR}/tmp ${CMAKE_DIR}/libemos-targets-release.cmake
	# Change default from emos to emos_shared to link against shared libs in metview, etc.
	grep -v LIBEMOS_SELF_LIBRARIES ${CMAKE_DIR}/libemos-config.cmake | \
		sed -e 's%.*set( libemos_BASE_DIR.*%set( libemos_BASE_DIR /usr )%' > ${CMAKE_DIR}/tmp
	mv ${CMAKE_DIR}/tmp ${CMAKE_DIR}/libemos-config.cmake  
	echo >> ${CMAKE_DIR}/libemos-config.cmake 
	echo "set( LIBEMOS_SELF_LIBRARIES    "emos_shared" )" >> ${CMAKE_DIR}/libemos-config.cmake

=== debian/watch ===
version=3
https://software.ecmwf.int/wiki/display/EMOS/Releases /wiki/download/attachments/3473472/libemos\-(.+)\-Source\.tar\.gz\?api=v2
